better error output
[automated-distro-installer] / fai-redep
index d7ba0043f9979f1292f620168417974c9f41d0e3..cd0888737541a0d475d7de19df177b193ee3fbf2 100755 (executable)
--- a/fai-redep
+++ b/fai-redep
@@ -1,13 +1,16 @@
-#!/bin/bash -lx
+#!/bin/bash -l
+set -x
 
 # Deploy fai configuration to faiserver,
 # then start a virtual machine to test the config.
 
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
-ssh root@faiserver rm -rf /srv/fai/config/\*
-scp -r /a/bin/fai/fai/config root@faiserver:/srv/fai
+cd $(dirname $(readlink -f "$BASH_SOURCE"))
+
+ssh root@faiserver rm -rf /srv/fai/config
+scp -r fai/config root@faiserver:/srv/fai
 # fai example pass: fai
 #ROOTPW='$1$kBnWcO.E$djxB128U7dMkrltJHPf6d1'
 
@@ -16,20 +19,28 @@ scp -r /a/bin/fai/fai/config root@faiserver:/srv/fai
 # echo "yoursecrectpassword" | mkpasswd -m sha-512 -s
 # On arch, best seems to be copy your shadow file to a temp location,
 # then passwd, get out the new pass, then copy the shadow file back.
-ssh root@faiserver tee -a /srv/fai/config/class/DEFAULT.var <<EOF
-ROOTPW='$(cat /p/shadow/standard)'
+
+f=/q/root/shadow/standard
+if s test -e $f; then
+    ssh root@faiserver tee -a /srv/fai/config/class/DEFAULT.var <<EOF
+ROOTPW='$(s cat $f)'
+EOF
+fi
+
+tpvar="$(s cat /q/root/shadow/traci-simple)"
+ssh root@faiserver tee -a /srv/fai/config/class/tp.var <<EOF
+ROOTPW='$tpvar'
 EOF
+
 scp ~/.ssh/id_rsa.pub \
     root@faiserver:/srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
-s scp -r /q/root/luks root@faiserver:/srv/fai/config/distro-install-common
-ssh root@faiserver chmod -R a+rX /srv/fai/config/distro-install-common
-
-s virshrm demohost ||:
-
-for f in /var/lib/libvirt/images/demohost{,b}; do
-    [[ -e $f ]] || s qemu-img create -o preallocation=metadata -f qcow2 $f 30G
-done
-# osinfo-query os | gr jessie
-s virt-install --os-variant debian8 --cpu host -n demohost --pxe -r 2048 --vcpus 1 \
-  --disk path=/var/lib/libvirt/images/demohost \
-  --disk path=/var/lib/libvirt/images/demohostb -w bridge=br0,mac=52:54:00:9c:ef:ad
+# todo: automatically disable faiserver after a period so
+# these files are not exposed.
+s scp -r /q/root/luks /q/root/shadow/traci{,-simple} \
+  root@faiserver:/srv/fai/config/distro-install-common
+scp /a/bin/devbyid root@faiserver:/srv/fai/nfsroot/usr/local/bin
+ssh root@faiserver bash <<'EOF'
+set -eE -o pipefail
+chmod 644 /srv/fai/config/files/home/ian/.ssh/authorized_keys/GRUB_PC
+chmod -R a+rX /srv/fai/config/distro-install-common
+EOF